﻿
using System;
using System.Web.UI;
using System.Web.UI.WebControls;
using Syncfusion.Grouping;
using System.Data.SqlServerCe;
using Syncfusion.Web.UI.WebControls.Grid.Grouping;
using System.Data;
using System.Collections.Generic;

public partial class EditingModes : System.Web.UI.Page
{
    SqlCeConnection myConnection = null;
    SqlCeDataAdapter myDataAdapter = null;
    DataSet myDataSet = null;


    /// <summary>
    /// Used in the aspx file to get the field value of a record.
    /// </summary>
    /// <param name="fieldName"></param>
    /// <param name="container"></param>
    /// <returns></returns>
    protected string GetFieldValue(string fieldName, GridFormEditCell container)
    {
        Record editRecord = container.CurrentRecord;
        return editRecord.GetValue(fieldName).ToString();
    }
   
    /// <summary>
    /// When the user clicks on the save changes button, go ahead and apply the user's changes to the current record.
    /// </summary>
    /// <param name="source"></param>
    /// <param name="e"></param>
    protected void GridGroupingControl1_BarButtonItemClicked(object source, Syncfusion.Web.UI.WebControls.Grid.Grouping.ButtonBarItemClickEventArgs e)
    {
        if (this.GridGroupingControl1.TableDescriptor.FormEditMode != TableEditMode.UseTemplateForm && this.GridGroupingControl1.TableDescriptor.FormEditMode != TableEditMode.UseInlineTemplateForm)
            return;

        if (e.ButtonBarItem.ButtonBarItemType == ButtonBarItemType.Save)
        {
            Record curRecord = this.GridGroupingControl1.FormEditCell.CurrentRecord;

            TextBox tb = this.GridGroupingControl1.FormEditCell.FindControl("CustomerIDTB") as TextBox;
            // If editing a current record, this will be disabled and the value will not be available.
            // But this will be enabled when editing a new record, then lets go ahead and process it.
            if (tb.Enabled)
                curRecord.SetValue("CustomerID", tb.Text);

            tb = this.GridGroupingControl1.FormEditCell.FindControl("ContNameTB") as TextBox;
            curRecord.SetValue("ContactName", tb.Text);

            tb = this.GridGroupingControl1.FormEditCell.FindControl("CompNameTB") as TextBox;
            curRecord.SetValue("CompanyName", tb.Text);

            tb = this.GridGroupingControl1.FormEditCell.FindControl("CityTB") as TextBox;
            curRecord.SetValue("City", tb.Text);

            tb = this.GridGroupingControl1.FormEditCell.FindControl("CountryTB") as TextBox;
            curRecord.SetValue("Country", tb.Text);

            this.GridGroupingControl1.Table.EndEdit();
            e.Handled = true;
        }
    }

   
    /// <summary>
    /// Page Load function
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void Page_Load(object sender, EventArgs e)
    {
        
        this.GridGroupingControl1.DataSourceControlRowDeleting += new GridDataSourceControlRowDeleteEventHandler(this.RowDeleting);
        this.GridGroupingControl1.DataSourceControlRowAdding += new GridDataSourceControlRowAddingEventHandler(this.RowAdding);
        this.GridGroupingControl1.DataSourceControlRowUpdating += new GridDataSourceControlRowUpdateEventHandler(this.RowUpdating);
        this.GridGroupingControl1.BarButtonItemClicked += new BarButtonItemClickEventHandler(GridGroupingControl1_BarButtonItemClicked);

        this.GridGroupingControl1.TableDescriptor.Columns[2].HeaderText="Customer ID";
        this.GridGroupingControl1.TableDescriptor.Columns[3].HeaderText="Company Name";
        this.GridGroupingControl1.TableDescriptor.Columns[4].HeaderText="Contact Name";

        this.GridGroupingControl1.TableDescriptor.FormEditMode = TableEditMode.UseInlineTemplateForm;
        this.GridGroupingControl1.CurrentRecordContextChange += GridGroupingControl1_CurrentRecordContextChange;
        
    }

    void GridGroupingControl1_CurrentRecordContextChange(object sender, CurrentRecordContextChangeEventArgs e)
    {
        if (e.Action == CurrentRecordAction.EndEditCalled)
        {
            Record curRecord = this.GridGroupingControl1.FormEditCell.CurrentRecord;

            TextBox tb = this.GridGroupingControl1.FormEditCell.FindControl("CustomerIDTB") as TextBox;
            // If editing a current record, this will be disabled and the value will not be available.
            // But this will be enabled when editing a new record, then lets go ahead and process it.
            if (tb.Enabled)
                curRecord.SetValue("CustomerID", tb.Text);

            tb = this.GridGroupingControl1.FormEditCell.FindControl("ContNameTB") as TextBox;
            curRecord.SetValue("ContactName", tb.Text);

            tb = this.GridGroupingControl1.FormEditCell.FindControl("CompNameTB") as TextBox;
            curRecord.SetValue("CompanyName", tb.Text);

            tb = this.GridGroupingControl1.FormEditCell.FindControl("CityTB") as TextBox;
            curRecord.SetValue("City", tb.Text);

            tb = this.GridGroupingControl1.FormEditCell.FindControl("CountryTB") as TextBox;
            curRecord.SetValue("Country", tb.Text);

        }
    }
    
    /// <summary>
    /// Page Init function
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void Page_Init(object sender, EventArgs e)
    {
        //Bind data to GridGroupingControl.
        GetData();
    }
    private void RowAdding(object sender, GridDataSourceControlRowAddingEventArgs e)
    {
        e.Cancel = true;
        e.Handled = true;
    }

    private void RowDeleting(object sender, GridDataSourceControlRowDeleteEventArgs e)
    {
        e.Cancel = true;
        e.Handled = true;
    }

    private void RowUpdating(object sender, GridDataSourceControlRowUpdateEventArgs e)
    {
        e.Cancel = true;
        e.Handled = true;
    }
    // We cancel the Adding,Deleting,Updating the datasource in the following events in order to prevent changes to the data source in samples, 
    //also prevents from throwing an exception because the update command is not specified in  datasource properly.
    #region Prevent updation in datasource

    #endregion

    private void GetData()
    {
        //To allow ASP.NET to use SQL Compact Server 3.5
        AppDomain.CurrentDomain.SetData("SQLServerCompactEditionUnderWebHosting", true);

        string ConnectionString = @"Data Source=|DataDirectory|\Northwind.sdf";

        try
        {
            myConnection = new SqlCeConnection(ConnectionString);
            myDataAdapter = new SqlCeDataAdapter("SELECT * FROM Customers", myConnection);
            myDataSet = new DataSet();
            myDataAdapter.Fill(myDataSet);
            DataTable myDataTable = myDataSet.Tables[0];

            List<Customers> CustomersCollection = new List<Customers>();
            Customers Customers = null;
            foreach (DataRow dRow in myDataTable.Rows)
            {
                Customers = new Customers(dRow[5].ToString(), dRow[8].ToString(), dRow[0].ToString(), dRow[1].ToString(), dRow[2].ToString());
                CustomersCollection.Add(Customers);
            }
            this.GridGroupingControl1.DataSource = CustomersCollection;
        }
        catch (SqlCeException ex)
        {
            throw ex;
        }
        catch (Exception ex)
        {
            throw ex;
        }
    }
    [Serializable]
    protected class Customers
    {
        public Customers(string city, string country, string customerId, string companyname, string contactname)
        {
            this.City = city;
            this.Country = country;
            this.CustomerID = customerId;
            this.CompanyName = companyname;
            this.ContactName = contactname;
        }

        public Customers()
        {

        }
        public string City
        {
            get;
            set;
        }
        public string Country
        {
            get;
            set;
        }
        public string CustomerID
        {
            get;
            set;
        }
        public string CompanyName
        {
            get;
            set;
        }
        public string ContactName
        {
            get;
            set;
        }
    }
}
